﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestingLinqToSQL
{
    public class ProductController
    {
        public static List<Category> GetCategories()
        {
            HowToUnitTestDataContext db = CreateDataContext();
            var query = from c in db.Categories
                    select c;
            return query.ToList();
        }

        public static HowToUnitTestDataContext CreateDataContext()
        {
            return new HowToUnitTestDataContext();
        }

        public static Category GetCategory(string categoryTitle)
        {
            HowToUnitTestDataContext db = CreateDataContext();

            Category category = db.Categories.Single(c => c.Title == categoryTitle);
            return category;
        }

        public static List<Product> GetProductsForCategory(Category c)
        {
            HowToUnitTestDataContext db = CreateDataContext();
            var query = from p in db.Products
                        join pc in db.ProductCategories on p.id equals pc.ProductID
                        where pc.CategoryID == c.id
                        select p;

            return query.ToList();
        }

        public static Product GetProduct(int productID)
        {
            HowToUnitTestDataContext db = CreateDataContext();

            Product product = db.Products.Single(p => p.id == productID);
            return product;
        }
    }
}
